import { reactive as R, defineComponent as pl, ref as m, computed as te, onMounted as fl, watchEffect as ml, toRefs as vl, resolveComponent as v, resolveDirective as Ee, openBlock as p, createElementBlock as S, normalizeStyle as bl, unref as oe, createVNode as s, withCtx as r, withDirectives as T, createElementVNode as de, renderSlot as H, withKeys as De, Fragment as M, renderList as I, createBlock as b, mergeProps as B, createCommentVNode as W, vShow as hl, createTextVNode as L, toDisplayString as se, createSlots as Ve, resolveDynamicComponent as gl, normalizeProps as yl, guardReactiveProps as _l } from "vue";
import { ElNotification as Fl, ElMessage as Cl, ElMessageBox as ie } from "element-plus";
import { useRoute as El } from "vue-router";
const j = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Dl(u = { debug: !1 }) {
  const i = R({
    hooks: {}
  });
  return Object.keys(u).forEach((o) => {
    o !== "debug" && (i.hooks[o] = u[o]);
  }), {
    hookHandler: (o, V) => {
      let C = !1;
      try {
        u.debug && (console.group("DeBug\uFF1A", o), console.table(V.Data), console.groupEnd()), C = i.hooks[o](V);
      } catch {
        C = !0;
      }
      return C;
    }
  };
}
const Vl = {
  searchFormCollapse: !0,
  labelWidth: 120,
  menuAlign: "left",
  menuWidth: 310,
  pageSizes: [10, 20, 50, 100],
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  CrudRequest: () => {
  }
};
let Be, Pe;
const wl = (u) => {
  let i = {};
  Object.keys(u).forEach((f) => {
    f === "CrudRequest" ? (Be = u.CrudRequest, i.CrudRequest = u.CrudRequest) : i[f] = u[f];
  }), Pe = ue(Vl, i);
}, X = (u, i = "success") => {
  Fl({
    title: u,
    type: i,
    offset: 70,
    duration: 2500
  });
};
function U(u) {
  let i;
  try {
    i = Array.isArray(u) ? [] : {}, u === null && (i = null);
  } catch {
    i = {};
  }
  for (const f in u)
    typeof u[f] == "object" ? i[f] = U(u[f]) : i[f] = u[f];
  return i;
}
function ue(u, i) {
  let f = U(u);
  for (var o in i)
    f.hasOwnProperty(o) && typeof i[o] == "object" ? f[o] = ue(f[o], i[o]) : f[o] = i[o];
  return f;
}
function we(u, i) {
  let f = {}, o = Object.getOwnPropertyNames(u), V = Object.getOwnPropertyNames(i);
  return o.length === V.length && o.forEach((C) => {
    u[C] !== i[C] && (f[C] = i[C]);
  }), f;
}
const Bl = /* @__PURE__ */ L(" \u65B0\u589E "), Pl = /* @__PURE__ */ L(" \u6279\u91CF\u5220\u9664 "), Al = { class: "quick-search-area" }, Sl = /* @__PURE__ */ L("\u53D6\u6D88"), Hl = /* @__PURE__ */ L("\u63D0\u4EA4"), Rl = /* @__PURE__ */ pl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    queryAfterMount: { type: Boolean, default: !1 },
    openMultipleSelection: { type: Boolean },
    expand: { type: Boolean, default: !0 },
    PaginationLayout: { default: "->,total, sizes, prev, pager, next, jumper" },
    fullscreen: { type: Boolean },
    modalWidth: { default: "800px" },
    closeOnPressEscape: { type: Boolean },
    editFooterButton: { type: Boolean, default: !0 },
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    permission: { default: () => ["add", "edit", "delete", "deleteFlag", "remove"] }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(u, { expose: i, emit: f }) {
    const o = u;
    console.log({ props: o });
    const V = El(), C = m(), k = m(), g = R({
      ...ue(Pe, o.source.options)
    }), { hookHandler: z } = Dl(o.hooks);
    let q = te(() => Be);
    const P = m({ filter: {}, editor: {}, column: {} }), pe = m(), fe = m(), me = m(), ve = m(), re = m(), be = m(), F = m({}), Y = m({}), h = m({}), Z = m({}), Q = m([]), Ae = m([]), J = m(!1), he = m(), K = m("add"), $ = m(!1), N = m(!1), Se = m, E = m({
      current: 1,
      pageSize: 10,
      total: 0
    });
    if ((() => {
      const { filter: e, editor: l, column: t, columns: n } = o.source;
      let w = {};
      e.forEach((_) => {
        n[_].searchDefaultValue !== void 0 ? w[_] = n[_].searchDefaultValue : w[_] = void 0, P.value.filter[_] = n[_];
      }), re.value = U(w), F.value = U(re.value);
      let x = {};
      l.forEach((_) => {
        n[_].addDefaultValue !== void 0 ? x[_] = n[_].addDefaultValue : x[_] = void 0, P.value.editor[_] = n[_];
      }), be.value = U(x), t.forEach((_) => {
        P.value.column[_] = n[_];
      }), pe.value = n;
    })(), V.params.data) {
      console.log("\u8DEF\u7531\u4F20\u53C2\uFF1A", V.params.data);
      let e = V.params.data, l = JSON.parse(e);
      Y.value = ue(Y.value, l);
    }
    const He = te(() => {
      let e = {};
      const l = ["el-input", "el-input-number", "el-select", "el-date-picker"];
      return o.source.filter.forEach((t) => {
        l.includes(P.value.filter[t].type) && (e[t] = P.value.filter[t]);
      }), e;
    }), Re = te(() => {
      let e = {};
      const l = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-cascader", "el-upload"];
      return o.source.editor.forEach((t) => {
        l.includes(P.value.editor[t].type) && O(P.value.editor[t], "visible") && (e[t] = P.value.editor[t]);
      }), e;
    }), ge = m(0), ye = m(0);
    fl(() => {
      C.value.style.display = "block", ge.value = document.documentElement.clientHeight - 50 - 20 - 40 - 56 - C.value.clientHeight - k.value.clientHeight - 20, C.value.style.display = "none", ye.value = document.documentElement.clientHeight - 50 - 20 - 40 - 56 - k.value.clientHeight - 20, o.queryAfterMount && D(), o.watchData && o.watchData.forEach((e) => {
        ml(() => {
          h.value[e.id] && (console.log(h.value[e.id]), e.data.forEach((l) => {
            l.data[e.id] = h.value[e.id], Xe(l);
          }));
        });
      }), console.log(pe.value);
    });
    const D = () => {
      J.value = !0;
      const e = R({
        ...F.value,
        ...Y.value
      });
      if (!!z(j.beforeQueryHandler, { CrudState: y, Data: e })) {
        for (const l in e)
          Object.prototype.hasOwnProperty.call(e, l) && (typeof e[l] == "string" && (console.log(e, l, e[l]), e[l] = e[l].trim(), e[l] === "" && (e[l] = void 0)), typeof e[l] == "object" && console.log("\u53D6\u503C\u4E3AObject\uFF0C\u8FD8\u672A\u505A\u5904\u7406"), typeof e[l] == "number" && console.log("\u53D6\u503C\u4E3Anumber\uFF0C\u8FD8\u672A\u505A\u5904\u7406"));
        q.value({
          url: o.url,
          name: g.apiName.query,
          data: {
            pagenum: E.value.current,
            pagesize: E.value.pageSize,
            ...e
          }
        }).then((l) => {
          const { data: t, page: n } = l;
          xe(t, e), E.value.total = n.total, J.value = !1;
        }).catch(() => {
          J.value = !1;
        });
      }
    }, xe = (e, l) => {
      Object.keys(l).filter((n) => l[n] != null).length == 0 && (ve.value = e), ve.value = U(e), z(j.afterQueryHandler, { CrudState: y, Data: e }) && (me.value = U(e));
    }, Me = () => {
      F.value = U(re.value), D();
    }, Ue = () => {
      h.value = U(be.value);
      const e = R({ ...h.value });
      !z(j.beforeAddHandler, { CrudState: y, Data: e }) || (K.value = "add", $.value = !0);
    }, ke = (e) => {
      const l = R({
        ...e
      });
      !z(j.beforeEditHandler, { CrudState: y, Data: l }) || (Object.keys(l).forEach((t) => {
        h.value[t] = l[t], Z.value[t] = l[t];
      }), K.value = "edit", $.value = !0);
    }, ee = async (e) => {
      !e || await e.validate((l) => {
        if (l) {
          const t = R({
            ...h.value
          });
          if (!z(j.beforeSubmitHandler, { CrudState: y, Data: t }))
            return;
          y.Mode === "add" ? Ne(t) : ze(t);
        }
      });
    }, Ne = (e) => {
      N.value = !0;
      let l = e;
      e.FormData instanceof FormData && (l = e.FormData), q.value({ url: o.url, name: g.apiName.add, data: l }).then(() => {
        $.value = !1, X("\u65B0\u589E\u6210\u529F"), D(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, ze = (e) => {
      N.value = !0;
      let l = e;
      if (e.FormData instanceof FormData)
        l = e.FormData;
      else {
        const t = o.rowKey, n = R({});
        o.rowKeys && o.rowKeys.forEach((x) => {
          n[x] = e[x];
        });
        const w = we(Z.value, l);
        if (JSON.stringify(w) === "{}")
          return N.value = !1, Cl({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        l = {
          [t]: e[t],
          ...n,
          ...we(Z.value, l)
        };
      }
      q.value({ url: o.url, name: g.apiName.edit, data: l }).then(() => {
        $.value = !1, X("\u4FEE\u6539\u6210\u529F"), D(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, qe = (e) => {
      ie.confirm(`\u786E\u5B9A\u8981 \u201C${e.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = R({
          row: { ...e },
          [o.rowKey]: e[o.rowKey],
          deleteFlag: e.deleteFlag == 0 ? 1 : 0
        });
        !z(j.beforedisabledHandler, { CrudState: y, Data: l }) || q.value({
          url: o.url,
          name: g.apiName.deleteFlag,
          data: l
        }).then(() => {
          X("\u64CD\u4F5C\u6210\u529F"), D();
        });
      }).catch(() => {
      });
    }, Ke = (e) => {
      ie.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = R({
          row: { ...e },
          [o.rowKey]: e[o.rowKey],
          deleteFlag: e.deleteFlag == 0 ? 1 : 0
        });
        !z(j.beforeDeteleHandler, { CrudState: y, Data: l }) || q.value({
          url: o.url,
          name: g.apiName.delete,
          data: l
        }).then(() => {
          X("\u5220\u9664\u6210\u529F"), D();
        });
      }).catch(() => {
      });
    }, $e = () => {
      ie.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const e = Q.value.map((l) => l[o.rowKey]);
        q.value({
          url: o.url,
          name: g.apiName.remove,
          data: { [o.rowKey]: e, selection: Q.value }
        }).then(() => {
          X("\u6279\u91CF\u5220\u9664\u6210\u529F"), Q.value = [], fe.value.clearSelection(), D();
        });
      }).catch(() => {
      });
    }, le = (e) => e.formProps && e.formProps.type ? e.range ? e.formProps.type + "range" : e.formProps.type : "date", O = (e, l) => {
      if (l === "disabled")
        return typeof e.disabled == "function" ? e.disabled(y, K.value) : !1;
      if (l === "visible")
        return typeof e.visible == "function" ? e.visible(y, K.value) : !0;
    }, Oe = (e, l, t, n) => {
      f("cell-click", { row: e, column: l, cell: t, event: n });
    }, Te = (e, l, t) => {
      f("row-contextmenu", { row: e, column: l, event: t }, y);
    }, We = (e) => {
      Q.value = e;
    }, je = (e) => {
      const { formProps: l = {} } = e;
      let t = { ...l };
      return Object.keys(t).forEach((n) => {
        typeof t[n] == "function" && (t[n] = t[n].bind(this, y, K.value), n == "disabled" && console.log(t[n]));
      }), t;
    }, Le = (e, l) => {
      let t = { ...e };
      return Object.keys(t).forEach((n) => {
        typeof t[n] == "function" && (t[n] = t[n].bind(this, y, l));
      }), t;
    }, Ie = (e) => {
      E.value.pageSize = e;
      const l = Math.floor(E.value.total / E.value.pageSize);
      l === 0 ? E.value.current = 1 : E.value.current = l, D();
    }, Qe = (e) => {
      E.value.current = e, E.value.current != null && D();
    }, Je = (e, l, t) => {
      if (l.type === "el-select") {
        const n = l.formProps.options.findIndex((w) => w.value == e.row[t]);
        return n === -1 ? e.row[t] : l.formProps.options[n].label;
      } else
        return e.row[t];
    }, Ge = te(() => ({ ...o.wrapperStyle })), Xe = (e) => {
      q.value({ url: e.url, name: e.name, data: e.data }).then((l) => {
        P.value.editor[e.key].formProps.options = l.data.map((t) => {
          if (typeof e.label == "string")
            return {
              value: t[e.value],
              label: t[e.label]
            };
          if (typeof e.label == "object")
            return {
              value: t[e.value],
              label: t[e.label[0]] + "--" + t[e.label[1]]
            };
        });
      });
    }, y = R({
      ElementArrs: P,
      searchModel: F,
      searchFormValue: Y,
      editModel: h,
      editFormValue: Z,
      uploadFiles: Ae,
      tableLoading: J,
      Pagination: E,
      Mode: K,
      queryRecord: D
    });
    return i({
      ...vl(y)
    }), (e, l) => {
      const t = v("el-input"), n = v("el-form-item"), w = v("el-col"), x = v("el-input-number"), _ = v("el-option"), _e = v("el-select"), ne = v("el-date-picker"), Ye = v("el-row"), Fe = v("el-form"), Ze = v("el-collapse-transition"), A = v("el-button"), el = v("el-empty"), ae = v("el-table-column"), ll = v("el-descriptions-item"), al = v("el-descriptions"), tl = v("el-button-group"), ol = v("el-table"), ul = v("el-pagination"), rl = v("el-cascader"), nl = v("el-upload"), dl = v("el-scrollbar"), Ce = v("el-card"), sl = v("el-dialog"), G = Ee("permission"), il = Ee("loading");
      return p(), S("div", {
        class: "wrapp",
        style: bl(oe(Ge))
      }, [
        s(Ce, { style: { border: "0" } }, {
          default: r(() => [
            T(s(Ze, null, {
              default: r(() => [
                de("div", {
                  id: "plain",
                  ref_key: "searchRef",
                  ref: C
                }, [
                  H(e.$slots, "search-form", {
                    editModel: F.value,
                    queryRecord: D,
                    CrudState: y
                  }, void 0, !0),
                  s(Fe, {
                    model: F.value,
                    "label-width": g.labelWidth,
                    onKeyup: De(D, ["enter", "native"])
                  }, {
                    default: r(() => [
                      s(Ye, null, {
                        default: r(() => [
                          H(e.$slots, "search-form-top", { CrudState: y }, void 0, !0),
                          (p(!0), S(M, null, I(oe(He), (a, d) => (p(), S(M, null, [
                            a.type === "el-input" ? (p(), b(w, {
                              key: 0,
                              md: 6,
                              lg: 6
                            }, {
                              default: r(() => [
                                s(n, {
                                  label: a.label
                                }, {
                                  default: r(() => [
                                    s(t, B({
                                      style: { width: "100%" },
                                      modelValue: F.value[d],
                                      "onUpdate:modelValue": (c) => F.value[d] = c,
                                      clearable: "",
                                      placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                    }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                  ]),
                                  _: 2
                                }, 1032, ["label"])
                              ]),
                              _: 2
                            }, 1024)) : a.type === "el-input-number" ? (p(), b(w, {
                              key: 1,
                              md: 6,
                              lg: 6
                            }, {
                              default: r(() => [
                                s(n, {
                                  label: a.label
                                }, {
                                  default: r(() => [
                                    s(x, B({
                                      style: { width: "100%" },
                                      modelValue: F.value[d],
                                      "onUpdate:modelValue": (c) => F.value[d] = c,
                                      placeholder: "\u8BF7\u8F93\u5165"
                                    }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                  ]),
                                  _: 2
                                }, 1032, ["label"])
                              ]),
                              _: 2
                            }, 1024)) : a.type === "el-select" ? (p(), b(w, {
                              key: 2,
                              md: 6,
                              lg: 6
                            }, {
                              default: r(() => [
                                s(n, {
                                  label: a.label
                                }, {
                                  default: r(() => [
                                    s(_e, B({
                                      style: { width: "100%" },
                                      modelValue: F.value[d],
                                      "onUpdate:modelValue": (c) => F.value[d] = c,
                                      clearable: "",
                                      placeholder: "\u8BF7\u9009\u62E9"
                                    }, a.formProps), {
                                      default: r(() => [
                                        (p(!0), S(M, null, I(a.formProps.options, (c) => (p(), b(_, {
                                          key: c.value,
                                          label: c.label,
                                          value: c.value
                                        }, null, 8, ["label", "value"]))), 128))
                                      ]),
                                      _: 2
                                    }, 1040, ["modelValue", "onUpdate:modelValue"])
                                  ]),
                                  _: 2
                                }, 1032, ["label"])
                              ]),
                              _: 2
                            }, 1024)) : a.type === "el-date-picker" && le(a).includes("range") ? (p(), b(w, {
                              key: 3,
                              xs: 12,
                              sm: 12,
                              md: 12,
                              lg: 12
                            }, {
                              default: r(() => [
                                s(n, {
                                  label: a.label
                                }, {
                                  default: r(() => [
                                    s(ne, B({
                                      style: { width: "100%" },
                                      modelValue: F.value[d],
                                      "onUpdate:modelValue": (c) => F.value[d] = c,
                                      "start-placeholder": "\u8D77\u59CB",
                                      "range-separator": "\u81F3",
                                      "end-placeholder": "\u7ED3\u675F",
                                      placeholder: "\u8BF7\u9009\u62E9",
                                      clearable: ""
                                    }, a.formProps, {
                                      type: le(a)
                                    }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                  ]),
                                  _: 2
                                }, 1032, ["label"])
                              ]),
                              _: 2
                            }, 1024)) : a.type === "el-date-picker" && le(a) ? (p(), b(w, {
                              key: 4,
                              md: 6,
                              lg: 6
                            }, {
                              default: r(() => [
                                s(n, {
                                  label: a.label
                                }, {
                                  default: r(() => [
                                    s(ne, B({
                                      style: { width: "100%" },
                                      modelValue: F.value[d],
                                      "onUpdate:modelValue": (c) => F.value[d] = c,
                                      "start-placeholder": "\u8D77\u59CB",
                                      "range-separator": "\u81F3",
                                      "end-placeholder": "\u7ED3\u675F",
                                      placeholder: "\u8BF7\u9009\u62E9",
                                      clearable: ""
                                    }, a.formProps, {
                                      type: le(a)
                                    }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                  ]),
                                  _: 2
                                }, 1032, ["label"])
                              ]),
                              _: 2
                            }, 1024)) : W("", !0)
                          ], 64))), 256)),
                          H(e.$slots, "search-form-bottom", { CrudState: y }, void 0, !0)
                        ]),
                        _: 3
                      })
                    ]),
                    _: 3
                  }, 8, ["model", "label-width", "onKeyup"])
                ], 512)
              ]),
              _: 3
            }, 512), [
              [hl, !g.searchFormCollapse]
            ]),
            de("div", {
              ref_key: "buttonAreaRef",
              ref: k,
              class: "button_area"
            }, [
              T((p(), b(A, {
                type: "primary",
                icon: "plus",
                onClick: Ue
              }, {
                default: r(() => [
                  Bl
                ]),
                _: 1
              })), [
                [G, { permission: u.permission, access: [g.permission.add] }]
              ]),
              u.openMultipleSelection ? T((p(), b(A, {
                key: 0,
                disabled: Q.value.length <= 0,
                type: "danger",
                icon: "delete",
                onClick: $e
              }, {
                default: r(() => [
                  Pl
                ]),
                _: 1
              }, 8, ["disabled"])), [
                [G, { permission: u.permission, access: [g.permission.remove] }]
              ]) : W("", !0),
              H(e.$slots, "button-area", { CrudState: y }, void 0, !0)
            ], 512),
            T((p(), b(ol, {
              ref_key: "tableRef",
              ref: fe,
              data: me.value,
              "row-key": u.rowKey,
              "max-height": g.searchFormCollapse ? ye.value : ge.value,
              onCellClick: Oe,
              onRowContextmenu: Te,
              onSelectionChange: We
            }, {
              empty: r(() => [
                s(el, {
                  "image-size": 80,
                  description: "\u6682\u65E0\u6570\u636E"
                })
              ]),
              default: r(() => [
                u.openMultipleSelection ? (p(), b(ae, {
                  key: 0,
                  type: "selection",
                  width: 44
                })) : W("", !0),
                u.expand ? (p(), b(ae, {
                  key: 1,
                  type: "expand",
                  label: "###",
                  width: 55
                }, {
                  default: r((a) => [
                    s(al, {
                      column: 3,
                      border: ""
                    }, {
                      default: r(() => [
                        (p(!0), S(M, null, I(u.source.columns, (d, c) => (p(), S(M, { key: c }, [
                          d.hidden ? W("", !0) : (p(), b(ll, {
                            key: 0,
                            label: d.label
                          }, {
                            default: r(() => [
                              L(se(Je(a, d, c)), 1)
                            ]),
                            _: 2
                          }, 1032, ["label"]))
                        ], 64))), 128))
                      ]),
                      _: 2
                    }, 1024)
                  ]),
                  _: 1
                })) : W("", !0),
                (p(!0), S(M, null, I(P.value.column, (a, d) => {
                  var c;
                  return p(), b(ae, B({
                    key: d,
                    align: a.align || "left"
                  }, a.tableProps, {
                    width: a.tableProps ? (c = a.tableProps) == null ? void 0 : c.width : void 0,
                    label: a.label,
                    prop: d
                  }), Ve({ _: 2 }, [
                    a.columnSlot ? {
                      name: "default",
                      fn: r((cl) => [
                        (p(), b(gl(a.columnSlot.is), yl(_l(Le(a.columnSlot, cl))), null, 16))
                      ])
                    } : void 0
                  ]), 1040, ["align", "width", "label", "prop"]);
                }), 128)),
                H(e.$slots, "default", {}, void 0, !0),
                s(ae, {
                  align: g.menuAlign || "left",
                  width: o.keyName ? g.menuWidth : g.menuWidth - 150
                }, {
                  header: r(() => [
                    de("div", Al, [
                      o.keyName ? (p(), b(t, {
                        key: 0,
                        style: { width: "150px" },
                        modelValue: F.value[o.keyName],
                        "onUpdate:modelValue": l[0] || (l[0] = (a) => F.value[o.keyName] = a),
                        placeholder: "\u6A21\u7CCA\u67E5\u627E",
                        clearable: "",
                        onKeyup: De(D, ["enter", "native"])
                      }, null, 8, ["modelValue", "onKeyup"])) : W("", !0),
                      s(tl, null, {
                        default: r(() => [
                          s(A, {
                            color: "#67c23a",
                            icon: "search",
                            onClick: D
                          }),
                          s(A, {
                            color: "#e6a23c",
                            icon: "refresh",
                            onClick: Me
                          }),
                          s(A, {
                            color: "#409eff",
                            icon: "expand",
                            onClick: l[1] || (l[1] = (a) => g.searchFormCollapse = !g.searchFormCollapse)
                          })
                        ]),
                        _: 1
                      })
                    ])
                  ]),
                  default: r((a) => [
                    H(e.$slots, "menu-head", { scope: a }, void 0, !0),
                    T((p(), b(A, {
                      plain: "",
                      type: a.row.deleteFlag ? "danger" : "success",
                      onClick: (d) => qe(a.row)
                    }, {
                      default: r(() => [
                        L(se(a.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                      ]),
                      _: 2
                    }, 1032, ["type", "onClick"])), [
                      [G, { permission: u.permission, access: [g.permission.deleteFlag] }]
                    ]),
                    T(s(A, {
                      plain: "",
                      type: "primary",
                      icon: "edit",
                      onClick: (d) => ke(a.row)
                    }, null, 8, ["onClick"]), [
                      [G, { permission: u.permission, access: [g.permission.edit] }]
                    ]),
                    T(s(A, {
                      type: "danger",
                      icon: "delete",
                      onClick: (d) => Ke(a.row)
                    }, null, 8, ["onClick"]), [
                      [G, { permission: u.permission, access: [g.permission.delete] }]
                    ]),
                    H(e.$slots, "menu-tail", { scope: a }, void 0, !0)
                  ]),
                  _: 3
                }, 8, ["align", "width"])
              ]),
              _: 3
            }, 8, ["data", "row-key", "max-height"])), [
              [il, J.value]
            ]),
            s(ul, {
              style: { "margin-top": "20px" },
              background: "",
              currentPage: E.value.current,
              "onUpdate:currentPage": l[2] || (l[2] = (a) => E.value.current = a),
              onSizeChange: Ie,
              onCurrentChange: Qe,
              "page-sizes": g.pageSizes,
              "page-size": E.value.pageSize,
              layout: u.PaginationLayout,
              total: E.value.total
            }, null, 8, ["currentPage", "page-sizes", "page-size", "layout", "total"]),
            s(sl, {
              "custom-class": "DialogVisible",
              ref: "dialogRef",
              modelValue: $.value,
              "onUpdate:modelValue": l[5] || (l[5] = (a) => $.value = a),
              title: K.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
              width: "50%",
              "destroy-on-close": ""
            }, Ve({
              default: r(() => [
                s(Ce, {
                  class: "edit-form-card",
                  shadow: "never"
                }, {
                  default: r(() => [
                    s(dl, {
                      height: "350px",
                      "max-height": "350px"
                    }, {
                      default: r(() => [
                        H(e.$slots, "edit-form", {
                          editModel: h.value,
                          handleSubmit: ee,
                          CrudState: y
                        }, void 0, !0),
                        s(Fe, {
                          id: "DialogVisible-edit-form",
                          class: "edit-form",
                          ref_key: "FormRef",
                          ref: he,
                          model: h.value,
                          "label-width": g.labelWidth
                        }, {
                          default: r(() => [
                            H(e.$slots, "edit-form-top-item", {
                              editModel: h.value,
                              handleSubmit: ee,
                              CrudState: y
                            }, void 0, !0),
                            (p(!0), S(M, null, I(oe(Re), (a, d) => (p(), S(M, { key: d }, [
                              a.type === "el-input" ? (p(), b(n, {
                                key: 0,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(t, B({
                                    modelValue: h.value[d],
                                    "onUpdate:modelValue": (c) => h.value[d] = c,
                                    clearable: "",
                                    placeholder: "\u8BF7\u8F93\u5165",
                                    disabled: O(a, "disabled")
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : a.type === "el-input-number" ? (p(), b(n, {
                                key: 1,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(x, B({
                                    modelValue: h.value[d],
                                    "onUpdate:modelValue": (c) => h.value[d] = c,
                                    placeholder: "\u8BF7\u8F93\u5165",
                                    disabled: O(a, "disabled")
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : a.type === "el-select" ? (p(), b(n, {
                                key: 2,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(_e, B({
                                    style: { width: "220px" },
                                    modelValue: h.value[d],
                                    "onUpdate:modelValue": (c) => h.value[d] = c,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    disabled: O(a, "disabled")
                                  }, a.formProps), {
                                    default: r(() => [
                                      (p(!0), S(M, null, I(a.formProps.options, (c) => (p(), b(_, {
                                        key: c.value,
                                        label: c.label,
                                        value: c.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : a.type === "el-date-picker" ? (p(), b(n, {
                                key: 3,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(ne, B({
                                    modelValue: h.value[d],
                                    "onUpdate:modelValue": (c) => h.value[d] = c,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    disabled: O(a, "disabled")
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : a.type === "el-cascader" ? (p(), b(n, {
                                key: 4,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(rl, B({
                                    modelValue: h.value[d],
                                    "onUpdate:modelValue": (c) => h.value[d] = c,
                                    props: a.formProps.props,
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    "show-all-levels": !1,
                                    disabled: O(a, "disabled")
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : a.type === "el-upload" ? (p(), b(n, {
                                key: 5,
                                label: a.label,
                                prop: d,
                                rules: a.rules
                              }, {
                                default: r(() => [
                                  s(nl, B({
                                    action: "",
                                    "show-file-list": !1
                                  }, je(a)), {
                                    default: r(() => [
                                      s(A, {
                                        type: "primary",
                                        disabled: O(a, "disabled")
                                      }, {
                                        default: r(() => [
                                          L(se(a.formProps.title), 1)
                                        ]),
                                        _: 2
                                      }, 1032, ["disabled"])
                                    ]),
                                    _: 2
                                  }, 1040)
                                ]),
                                _: 2
                              }, 1032, ["label", "prop", "rules"])) : W("", !0)
                            ], 64))), 128)),
                            H(e.$slots, "edit-form-bottom-item", {
                              editModel: h.value,
                              handleSubmit: ee,
                              CrudState: y
                            }, void 0, !0)
                          ]),
                          _: 3
                        }, 8, ["model", "label-width"])
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                })
              ]),
              _: 2
            }, [
              oe(Se) ? {
                name: "footer",
                fn: r(() => [
                  s(A, {
                    onClick: l[3] || (l[3] = (a) => $.value = !1)
                  }, {
                    default: r(() => [
                      Sl
                    ]),
                    _: 1
                  }),
                  s(A, {
                    type: "primary",
                    loading: N.value,
                    onClick: l[4] || (l[4] = (a) => ee(he.value))
                  }, {
                    default: r(() => [
                      Hl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              } : void 0
            ]), 1032, ["modelValue", "title"])
          ]),
          _: 3
        })
      ], 4);
    };
  }
});
const xl = (u, i) => {
  const f = u.__vccOpts || u;
  for (const [o, V] of i)
    f[o] = V;
  return f;
}, ce = /* @__PURE__ */ xl(Rl, [["__scopeId", "data-v-94681862"]]), Ml = {
  mounted(u, i, f) {
    const o = i.value.permission, V = i.value.access;
    let C = !1;
    for (let k = 0; k < V.length; k++)
      if (o.includes(V[k])) {
        C = !0;
        break;
      } else
        C = !1;
    C || u.parentNode && u.parentNode.removeChild(u);
  }
};
ce.install = (u) => {
  u.component("CrudEl", ce), u.directive("permission", Ml);
};
const zl = (u, i) => {
  i ? (i.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), wl(i), u.use(ce)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  ue as DataMerger,
  U as DeepClone,
  wl as InitSystem,
  zl as createCrudEl,
  j as hooksName,
  we as isObjEqual,
  Dl as useHooks
};
